// reads raw data from run_xxx.txt assigned to link indata
// writes ascii tuple file: ntuple.ascii using nout
#include <iostream>
#include <iomanip>
#include <fstream>		// needed by  ofstream to open output file
#include "histogram.h"
#include <string>

#define TAB '\t'

/*
RunNumber       RunType EventNumber     BufferSequenceNumber    BufferStartTimeLR       BufferStartTimeHR       BufferEndTimeLR BufferEndTimeHR 
RampTimeAdc     Mcp1TimeAdc     Mcp1PhAdc       Mcp2TimeAdc      Mcp2PhAdc       Mcp3TimeAdc     Mcp3PhAdc       Mcp4TimeAdc     Mcp4PhAdc       
Trig1TimeTdc    Trig2TimeTdc    CherenkovTimeTdc
 */

using namespace std;
 
unsigned  getbits( unsigned x, unsigned p, unsigned n)
{
    /* get n bits from position p */
        return  (( x >> (p+1-n)) & ~(~0 << n));
}


int main(int argc, char** argv)	{

	int i,j,k;
	int lineID, hdata1, ddata1, hdata2, ddata2;
	int feraID;
	int lineTotalLineCount = 0;
	int fileLineCount = 0;
	int linesInChunk=0;
	int bufferNumber=0, bufferCount=0;
	string titleString;
	int ptrToNext=1;
	bool notTheFirst=false, ptrData=false, firstTime = true ;
	bool ad114Header1 = false;
	bool ad114Header2 = false;
	bool ad114Header3 = false;
	bool ad114Header4 = false;
	int ad114Header1Count=0;
	int ad114Header2Count=0;
	int ad114Header3Count=0;
	int ad114Header4Count=0;
	int ntupleCount=0;
	//unsigned int event[18];
	unsigned int event[28];
	int errorType1count = 0;
	int nRunNumber=0, nEventCount=0;
	int runType=0;
	int bufferSequenceNumber=0;
	int bufferStartTimeLR=0, bufferStartTimeHR=0, bufferEndTimeLR=0, bufferEndTimeHR=0;
	int slowRampTimeAdc=0, fastRampTimeAdc=0, nRampTimeAdc=0; 
	int trig1TimeTdc=0, trig2TimeTdc=0, cherenkovTimeTdc=0;
	int nADC1time = 0, nADC2time = 0,  nADC1ph = 0, nADC2ph = 0;
	int nADC3time = 0, nADC4time = 0,  nADC3ph = 0, nADC4ph = 0;
	int nRealTimeLR1 =0, nRealTimeHR1=0;
	int nRealTimeLR2 =0, nRealTimeHR2=0;
	float clockTime=0;
	int initTime = 0;

	int scalerPointer=0;
	int nScalerValue[4]; 

#define N21
#define EVSIZE 21
#define ADCLOC 0
#define AD1LOC  17
#define AD2LOC  19

/*	definintions for N21
	0	ladc header		8005 8006
	1	adc channel 0
	...
	15	adc channel 14
	16	adc channel 15
	17	AD114 header		8801	8803
	18	AD114 data
	19	AD114 header		8802	8804
	20	AD114 data		
 */
/*
 -5     0       0       0       0       ScalerData Pointer
 -4     11      17      11      17      RealTime LR - Offset
 -3     79ff1   499697  86be7   551911  RealTime HR
 -2     4       4       5       5       CrateID
 -1     3e04    15876   3e04    15876   mPointers
 0      8005    32773   8006    32774   header
 1      c9      201     2e      46
 2      81a     2074    828     2088
 3      101a    4122    102b    4139
 4      1813    6163    181e    6174
 5      201a    8218    202d    8237
 6      281c    10268   2825    10277
 7      301c    12316   3030    12336
 8      3819    14361   382b    14379
 9      4020    16416   402c    16428
 10     481d    18461   4826    18470
 11     501b    20507   502a    20522
 12     5820    22560   5824    22564
 13     601e    24606   6029    24617
 14     681b    26651   682d    26669
 15     701e    28702   7027    28711
 16     7869    30825   79c8    31176
*/

	int inHexData=0, inDecData=0;
	int Mindex1=0, Mindex2=0;
	int data1H[16100], data1D[16100], data2H[16100], data2D[16100];
	int scaler1[3], scaler2[3];
	int realTimeLRc1=0, realTimeHRc1=0, realTimeLRc2=0, realTimeHRc2=0;
	int crateIDc1=0, crateIDc2=0;
	int memoryPointer=0,    memoryPointer1=0, memoryPointer2=0;

	int inIndex[EVSIZE], inHdata1[EVSIZE], inDdata1[EVSIZE], inHdata2[EVSIZE], inDdata2[EVSIZE];
	int inIndexM=0;
	int indexEv=0;
	int countADCheader1=0, countADCheader2=0;
	int countAD114header1=0, countAD114header2=0;
	int countAD114header3=0, countAD114header4=0;
	int lineCount=0, eventCount=0;
	int lAdc1ChAddr[16], lAdc2ChAddr[16];
	int lAdc1ChData[16], lAdc2ChData[16];

	float mADCtime1 = 3050.0;
	float lADCtime1 = 500.0;
	//histogram *hADCtime1 = new histogram( mADCtime1-lADCtime1, mADCtime1+lADCtime1, "h time ADC 1 data ");
	histogram *hADCtime1 = new histogram( 0.0, 5000.0, "h time ADC 1 data ");
	float mADCtime2 = 1850.0;
	float lADCtime2 = 500.0;
	//histogram *hADCtime2 = new histogram( mADCtime2-lADCtime2, mADCtime2+lADCtime2, "h time ADC 2 data ");
	histogram *hADCtime2 = new histogram( 0.0, 5000.0, "h time ADC 2 data ");

	histogram *hADCtime3 = new histogram( 0.0, 5000.0, "h time ADC 3 data ");
	histogram *hADCtime4 = new histogram( 0.0, 5000.0, "h time ADC 4 data ");

	 histogram *hADCpm1 = new histogram(0.0, 400.0, "h ph ADC 1 data ");
	 histogram *hADCpm2 = new histogram(0.0, 400.0, "h ph ADC 2 data ");
	 histogram *hADCpm3 = new histogram(0.0, 400.0, "h ph ADC 3 data ");
	 histogram *hADCpm4 = new histogram(0.0, 400.0, "h ph ADC 4 data ");
	int slowRampValue, fastRampValue;
//	adc is 10 bits so max is 1024
	 histogram *hSlowRamp = new histogram(0.0, 600.0 , "h Slow Ramp data ");
	 histogram *hFastRamp = new histogram(0.0, 600.0 , "h Fast Ramp data ");
	 histogram *hMemoryPtr1 = new histogram(0.0, 16100.0 , "h Memory Pointer 1 ");
	 histogram *hMemoryPtr2 = new histogram(0.0, 16100.0 , "h Memory Pointer 2 ");

	//cout << "Enter Run Description parameters: " << endl;
	//cout <<"runNumber  pulserDelay  pulserPeriod " << endl;
	//cin >> runNumber >> pulserDelay >> pulserPeriod;


	ifstream in("indata");


	// 1st line is text not data
	//getline(in,titleString);
	//fileLineCount++;
	
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;

   // open an output stream to make file of ascii nutples for ROOT
   ofstream nout("ntuple.ascii");
   if(!nout)
   {
     cout << "Cannot open output file.\n";
     return 1;
   }
	// output column names
	nout << "RunNumber"<<TAB<<"RunType"<< TAB<< "EventNumber" <<TAB<< "BufferSequenceNumber" 
			<<TAB<<"RealTimeLR"<<TAB<< "RealTimeHR"<<TAB<<"BufferEndTimeLR"
			<<TAB<<"LrRampTimeAdc" <<TAB<<"HrRampTimeAdc"
			<<TAB<<"Mcp1TimeAdc"<<TAB<< "Mcp1PhAdc" <<TAB<<"Mcp2TimeAdc"<<TAB<<"Mcp2PhAdc"
			<<TAB<<"Mcp3TimeAdc"<<TAB<< "Mcp3PhAdc" <<TAB<<"Mcp4TimeAdc"<<TAB<<"Mcp4PhAdc"
	                <<TAB<<"nScaler0"<<TAB<<"nScaler1"<< TAB << "CherenkovLatchADC" <<endl;
/*
RunNumber       RunType EventNumber     BufferSequenceNumber    BufferStartTimeLR       BufferStartTimeHR       BufferEndTimeLR BufferEndTimeHR
RampTimeAdc     Mcp1TimeAdc     Mcp1PhAdc       Mcp2TimeAdc      Mcp2PhAdc       Mcp3TimeAdc     Mcp3PhAdc       Mcp4TimeAdc     Mcp4PhAdc Trig1TimeTdc    Trig2TimeTdc    CherenkovTimeTdc
 */

   for (;;) {
	for ( j=0; j<6; j++) {
		in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		if ( inIndexM == -6 )  
		{ scalerPointer = inDecData;
		  if ( scalerPointer != 0) {
		    for ( k=0; k< scalerPointer; k++) {
		      in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		      nScalerValue[k] = inDecData;
		    }
		  }
		}
		if ( inIndexM == -5 )  nRunNumber  = inDecData;
		if ( inIndexM == -4 ) realTimeLRc1 = inDecData;
		if ( inIndexM == -3 ) realTimeHRc1 = inDecData;
		if ( inIndexM == -2 ) crateIDc1 = inDecData;
		if ( inIndexM == -1 ) memoryPointer1 = inDecData;
	}
	// detect an EOF
	if ( in.eof() != 0 ) {
		cout << "Found end of file..." << endl;
		break;
	}
	nRealTimeLR1 = realTimeLRc1;
	nRealTimeHR1 = realTimeHRc1;
	
	if ( crateIDc1 != 4 ) cerr << "Found wrong camac crate id " << crateIDc1 << endl;
	if ( memoryPointer1 != 15876 ) cerr << "Found abnormal memoryPointer1 = " << memoryPointer1 << endl;
	for ( j=0; j<memoryPointer1; j++) in >> inIndexM >> hex >> data1H[j] >> dec >> data1D[j];


	for ( j=0; j<6; j++) {
		in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		if ( inIndexM == -6 )  
		{ scalerPointer = inDecData;
		  if ( scalerPointer != 0) {
		    for ( k=0; k< scalerPointer; k++) {
		      in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		      nScalerValue[k] = inDecData;
		    }
		  }
		}
		if ( inIndexM == -5 ) nRunNumber = inDecData;
		if ( inIndexM == -4 ) realTimeLRc2 = inDecData;
		if ( inIndexM == -3 ) realTimeHRc2 = inDecData;
		if ( inIndexM == -2 ) crateIDc2 = inDecData;
		if ( inIndexM == -1 ) memoryPointer2 = inDecData;
	}
	if ( crateIDc2 != 5 ) cerr << "Found wrong camac crate id " << crateIDc2 << endl;
	if ( memoryPointer1 != 15876 ) cerr << "Found abnormal memoryPointer2 = " << memoryPointer2 << endl;
	for ( j=0; j<memoryPointer2; j++) in >> inIndexM >> hex >> data2H[j] >> dec >> data2D[j];

	memoryPointer = memoryPointer1;		/* assume pulser run */

	//cout << "memoryPointer1 = " << memoryPointer1 << " memoryPointer2 = " << memoryPointer1 << endl;
	//cout << "crateIDc1 = " << crateIDc1 << " crapteIDc2 = " <<  crateIDc2 << endl;

	for ( j=0; j<42; j++ ) cout << j << TAB << hex << data1H[j] << TAB << dec << data1D[j] 
					<< TAB << hex << data2H[j] << TAB << dec << data2D[j] << endl;

	lineCount = 0;
	int ptr1LadcHdr, ptr1OadcHdr1, ptr1OadcHdr2;
	int ptr2LadcHdr, ptr2OadcHdr1, ptr2OadcHdr2;
	ptr1LadcHdr = 0;
	ptr1OadcHdr1 = 17;
	ptr1OadcHdr2 = 19;
	ptr2LadcHdr = 0;
	ptr2OadcHdr1 = 17;
	ptr2OadcHdr2 = 19;
      for (j=0;j<memoryPointer;j=j+21) {
	
	//cout << "At j= " << j << " ptr1LadcHdr = " << ptr1LadcHdr 
	//			<< " ptr1OadcHdr1 = " << ptr1OadcHdr1
	//			<< " ptr1OadcHdr2 = " << ptr1OadcHdr2 << endl;

	if ( data1H[ptr1LadcHdr] != 0x8005 ) {
			cout << " Lecroy Header 8005 not alligned ... exit!" << endl;
			cout << " ptr1LadcHdr = " << ptr1LadcHdr << " data1H[ptr1LadcHdr] = " << data1H[ptr1LadcHdr] << endl;
			return 1;
	} else if ( data1H[ptr1OadcHdr1] != 0x8801 ) {
			cout << " Ortec ADC 1 Header 8801 not aligned ... exit!" << endl;
			return 1;
	} else if ( data1H[ptr1OadcHdr2] != 0x8802 ) {
			cout << " Ortec ADC 2 Header 8802 not aligned ... exit!" << endl;
                        return 1;
	}
	for ( i=0; i<21; i++ ) {
		inHdata1[i] = data1H[ptr1LadcHdr + i ];
		inDdata1[i] = data1D[ptr1LadcHdr + i ];
	}
	ptr1LadcHdr = ptr1LadcHdr + 21;
	ptr1OadcHdr1= ptr1OadcHdr1 + 21;
	ptr1OadcHdr2= ptr1OadcHdr2 + 21;
	


	if ( data2H[ptr2LadcHdr] != 0x8006 ) {
			cout << " Lecroy Header 8006 not alligned ... exit!" << endl;
			cout << " ptr2LadcHdr = " << ptr2LadcHdr << " data2H[ptr2LadcHdr] = " << data2H[ptr2LadcHdr] << endl;
			return 1;
	} else if ( data2H[ptr2OadcHdr1] != 0x8803 ) {
			cout << " Ortec ADC 1 Header 8803 not aligned ... exit!" << endl;
			return 1;
	} else if ( data2H[ptr2OadcHdr2] != 0x8804 ) {
			cout << " Ortec ADC 2 Header 8804 not aligned ... exit!" << endl;
                        return 1;
	}
	for ( i=0; i<21; i++ ) {
		inHdata2[i] = data2H[ptr2LadcHdr + i ];
		inDdata2[i] = data2D[ptr2LadcHdr + i ];
	}
	ptr2LadcHdr = ptr2LadcHdr + 21;
	ptr2OadcHdr1= ptr2OadcHdr1 + 21;
	ptr2OadcHdr2= ptr2OadcHdr2 + 21;



		int LeCroyADCheader1 = 0x8004;
		    LeCroyADCheader1 = 0x8005;	/* did this change */
		int LeCroyADCheader2 = 0x8006;

		if ( (inHdata1[ADCLOC] != LeCroyADCheader1) && (inHdata2[ADCLOC] != LeCroyADCheader2)) { /* lecroy 4300 ADC header */
			cout << "at line = "<<  lineCount <<  " ADC Alignment error...print inHdata" << endl;
			cout << "at line = " << lineCount << TAB << hex << inHdata1[ADCLOC] << TAB << inHdata2[ADCLOC] << endl;
			cout << dec << endl;
			return 1;
		} else {
			countADCheader1++;
			countADCheader2++;
		}
                if ( (inHdata1[AD1LOC] != 0x8801) && (inHdata2[AD1LOC] != 0x8803) ) {
                        cout << "ad114 Alignment error on 8801..." << endl;
                } else {
                        countAD114header1++;
                        countAD114header3++;
                        nADC1time = inHdata1[AD1LOC+1];
                        nADC3time = inHdata2[AD1LOC+1];
                }
#ifdef N21
                if ( (inHdata1[AD2LOC] != 0x8802) && (inHdata2[AD1LOC] != 0x8804) ) {
                        cout << "ad114 Alignment error on 8802..." << endl;
                } else {
                        countAD114header2++;
                        countAD114header4++;
                        nADC2time = inHdata1[AD2LOC+1];
                        nADC4time = inHdata2[AD2LOC+1];
                }
#endif

		eventCount++;
		for ( i=0; i<16; i++ ) {
			lAdc1ChAddr[i] = getbits(inHdata1[ADCLOC+1+i],15,5);
			lAdc1ChData[i] = getbits(inHdata1[ADCLOC+1+i],10,10);
			lAdc2ChAddr[i] = getbits(inHdata2[ADCLOC+1+i],15,5);
			lAdc2ChData[i] = getbits(inHdata2[ADCLOC+1+i],10,10);
		}
		
			hADCtime1->update( (float) inHdata1[AD1LOC+1] );
			hADCtime2->update( (float) inHdata1[AD2LOC+1] );
			hADCtime3->update( (float) inHdata2[AD1LOC+1] );
			hADCtime4->update( (float) inHdata2[AD2LOC+1] );
		hADCpm1->update( (float) lAdc1ChData[0] );
		hADCpm2->update( (float) lAdc1ChData[15] );
		hADCpm3->update( (float) lAdc2ChData[0] );
		hADCpm4->update( (float) lAdc2ChData[15] );
		slowRampValue = lAdc1ChData[1];
		fastRampValue = lAdc1ChData[2];
		nRampTimeAdc = slowRampValue;			/* choose only one for current ntuple */
		hSlowRamp->update( (float) slowRampValue );
		hFastRamp->update( (float) fastRampValue );
		hMemoryPtr1->update( (float) memoryPointer1);
		hMemoryPtr2->update( (float) memoryPointer2);
		if ( eventCount < 10 ) {
			for ( i=0; i<16; i++ ) {
				cout << " " << lAdc1ChAddr[i] 
				<< " "      << lAdc1ChData[i]
				<< " "      << lAdc2ChAddr[i]
				<< " "      << lAdc2ChData[i];
			}
			cout << endl;
		}
		// begin building ntuple to outup
		nADC1ph = lAdc1ChData[0];
		nADC2ph = lAdc1ChData[15];
		nADC3ph = lAdc2ChData[0];
		nADC4ph = lAdc2ChData[15];
		nEventCount = eventCount;
		nout << nRunNumber << TAB<< runType<<TAB << nEventCount <<TAB<< bufferSequenceNumber 
		<<TAB<< nRealTimeLR1 <<TAB<< nRealTimeHR1 <<TAB<< bufferEndTimeLR
		<<TAB<< slowRampValue << TAB <<  fastRampValue
		<<TAB<< nADC1time <<TAB<<  nADC1ph <<TAB<< nADC2time <<TAB<< nADC2ph
		<<TAB<< nADC3time <<TAB<<  nADC3ph <<TAB<< nADC4time <<TAB<< nADC4ph
		<<TAB<< nScalerValue[3] <<TAB<< nScalerValue[1] <<TAB<<  cherenkovTimeTdc
		                                        << endl;
     } // end of event build loop
   } // end of forever loop

	// output histograms.
	hADCtime1->printLong();
	hADCtime2->printLong();
	hADCtime3->printLong();
	hADCtime4->printLong();
	hADCpm1->print();
	hADCpm2->print();
	hADCpm3->print();
	hADCpm4->print();
	hSlowRamp->printLong();
	hFastRamp->printLong();
	hMemoryPtr1->printLong();
	hMemoryPtr2->printLong();

	cout << endl;
	cout << "Found " << lineCount << " lines."  << endl;
	cout << "eventCount      = " << eventCount << endl;
	cout << "errorType1count = " << errorType1count << endl;
	cout << "countADCheader1 = " << countADCheader1 << endl;
	cout << "countADCheader2 = " << countADCheader2 << endl;
	cout << "countAD114header1 = " << countAD114header1 << endl;
	cout << "countAD114header2 = " << countAD114header2 << endl;
	cout << "ntupleCount     = " << ntupleCount << endl;
	cout << "ADCtime1 count/mean/stdev = " << hADCtime1->get_sumIn() << TAB << hADCtime1->mean() << TAB << hADCtime1->stdev() << endl;
	cout << "ADCtime2 count/mean/stdev = " << hADCtime2->get_sumIn() << TAB << hADCtime2->mean() << TAB << hADCtime2->stdev() << endl;
	cout << "ADCtime3 count/mean/stdev = " << hADCtime3->get_sumIn() << TAB << hADCtime3->mean() << TAB << hADCtime3->stdev() << endl;
	cout << "ADCtime4 count/mean/stdev = " << hADCtime4->get_sumIn() << TAB << hADCtime4->mean() << TAB << hADCtime4->stdev() << endl;

	nout.close();

	return 0;

}
