// reads raw data from run_xxx.txt assigned to link indata
// writes ascii tuple file: ntuple.ascii using nout
#include <iostream>
#include <iomanip>
#include <fstream>		// needed by  ofstream to open output file
#include "histogram.h"
#include <string>

#define TAB '\t'

using namespace std;
 
unsigned  getbits( unsigned x, unsigned p, unsigned n)
{
    /* get n bits from position p */
        return  (( x >> (p+1-n)) & ~(~0 << n));
}


int main(int argc, char** argv)	{

	int i,j,k;
	int lineID, hdata1, ddata1, hdata2, ddata2;
	int feraID;
	int lineTotalLineCount = 0;
	int fileLineCount = 0;
	int linesInChunk=0;
	int bufferNumber=0, bufferCount=0;
	string titleString;
	int ptrToNext=1;
	bool notTheFirst=false, ptrData=false, firstTime = true ;
	bool ad114Header1 = false;
	bool ad114Header2 = false;
	bool ad114Header3 = false;
	bool ad114Header4 = false;
	int ad114Header1Count=0;
	int ad114Header2Count=0;
	int ad114Header3Count=0;
	int ad114Header4Count=0;
	int ntupleCount=0;
	//unsigned int event[18];
	unsigned int event[28];
	int errorType1count = 0;
	int nRunNumber=0, nEventCount=0;
	int runType=0;
	int bufferSequenceNumber=0;
	int bufferStartTimeLR=0, bufferStartTimeHR=0, bufferEndTimeLR=0, bufferEndTimeHR=0;
	int slowRampTimeAdc=0, fastRampTimeAdc=0, nRampTimeAdc=0; 
	int trig1TimeTdc=0, trig2TimeTdc=0, cherenkov=0;
	int nADC1time = 0, nADC2time = 0,  nADC1ph = 0, nADC2ph = 0;
	int nADC3time = 0, nADC4time = 0,  nADC3ph = 0, nADC4ph = 0;
	int nRealTimeLR1 =0, nRealTimeHR1=0;
	int nRealTimeLR2 =0, nRealTimeHR2=0;
	int nCherenkovADC=0;
	float clockTime=0;
	int initTime = 0;

	int scalerPointer=0;
	int nScalerValue[4];

#define N21
#define EVSIZE 21
#define ADCLOC 0
#define AD1LOC  17
#define AD2LOC  19

/*	definintions for N21
	0	ladc header		8005 8006
	1	adc channel 0
	...
	15	adc channel 14
	16	adc channel 15
	17	AD114 header		8801	8803
	18	AD114 data
	19	AD114 header		8802	8804
	20	AD114 data		
 */
/*
 -5     0       0       0       0       ScalerData Pointer
 -4     11      17      11      17      RealTime LR - Offset
 -3     79ff1   499697  86be7   551911  RealTime HR
 -2     4       4       5       5       CrateID
 -1     3e04    15876   3e04    15876   mPointers
 0      8005    32773   8006    32774   header
 1      c9      201     2e      46
 2      81a     2074    828     2088
 3      101a    4122    102b    4139
 4      1813    6163    181e    6174
 5      201a    8218    202d    8237
 6      281c    10268   2825    10277
 7      301c    12316   3030    12336
 8      3819    14361   382b    14379
 9      4020    16416   402c    16428
 10     481d    18461   4826    18470
 11     501b    20507   502a    20522
 12     5820    22560   5824    22564
 13     601e    24606   6029    24617
 14     681b    26651   682d    26669
 15     701e    28702   7027    28711
 16     7869    30825   79c8    31176
*/

	int inHexData=0, inDecData=0;
	int Mindex1=0, Mindex2=0;
	int data1H[16100], data1D[16100], data2H[16100], data2D[16100];
	int scaler1[3], scaler2[3];
	int realTimeLRc1=0, realTimeHRc1=0, realTimeLRc2=0, realTimeHRc2=0;
	int crateIDc1=0, crateIDc2=0;
	int memoryPointer=0,    memoryPointer1=0, memoryPointer2=0;
	int memoryIndex1=0, memoryIndex2=0;

	int inIndex[EVSIZE], inHdata1[EVSIZE], inDdata1[EVSIZE], inHdata2[EVSIZE], inDdata2[EVSIZE];
	int inIndexM=0;
	int indexEv=0;
	int countADCheader1=0, countADCheader2=0;
	int countAD114header1=0, countAD114header2=0;
	int countAD114header3=0, countAD114header4=0;
	int lineCount=0, eventCount=0;
	int lAdc1ChAddr[16], lAdc2ChAddr[16];
	int lAdc1ChData[16], lAdc2ChData[16];

	int missingOrtecHeaderCount[4] = {0,0,0,0};
	int offSet1, offSet2;

	bool flag1, flag2, flag3, flag4;
	int evCountHdr=0;
	int evCountHdr1=0, evCountHdr2=0;
	int LadcHeader1counter=0, LadcHeader2counter=0;

        int correctedOadcHeader1, correctedOadcData1;
        int correctedOadcHeader2, correctedOadcData2;
        int correctedOadcHeader3, correctedOadcData3;
        int correctedOadcHeader4, correctedOadcData4;

	int ptr1LadcHdr, ptr1OadcHdr1, ptr1OadcHdr2;
	int ptr2LadcHdr, ptr2OadcHdr1, ptr2OadcHdr2;

	float mADCtime1 = 3050.0;
	float lADCtime1 = 500.0;
	//histogram *hADCtime1 = new histogram( mADCtime1-lADCtime1, mADCtime1+lADCtime1, "h time ADC 1 data ");
	histogram *hADCtime1 = new histogram( 0.0, 5000.0, "h time ADC 1 data ");
	float mADCtime2 = 1850.0;
	float lADCtime2 = 500.0;
	//histogram *hADCtime2 = new histogram( mADCtime2-lADCtime2, mADCtime2+lADCtime2, "h time ADC 2 data ");
	histogram *hADCtime2 = new histogram( 0.0, 5000.0, "h time ADC 2 data ");

	histogram *hADCtime3 = new histogram( 0.0, 5000.0, "h time ADC 3 data ");
	histogram *hADCtime4 = new histogram( 0.0, 5000.0, "h time ADC 4 data ");

	 histogram *hADCpm1 = new histogram(0.0, 400.0, "h ph ADC 1 data ");
	 histogram *hADCpm2 = new histogram(0.0, 400.0, "h ph ADC 2 data ");
	 histogram *hADCpm3 = new histogram(0.0, 400.0, "h ph ADC 3 data ");
	 histogram *hADCpm4 = new histogram(0.0, 400.0, "h ph ADC 4 data ");
	int slowRampValue, fastRampValue;
//	adc is 10 bits so max is 1024
	 histogram *hSlowRamp = new histogram(0.0, 600.0 , "h Slow Ramp data ");
	 histogram *hFastRamp = new histogram(0.0, 600.0 , "h Fast Ramp data ");

	//cout << "Enter Run Description parameters: " << endl;
	//cout <<"runNumber  pulserDelay  pulserPeriod " << endl;
	//cin >> runNumber >> pulserDelay >> pulserPeriod;


	ifstream in("indata");


	// 1st line is text not data
	//getline(in,titleString);
	//fileLineCount++;
	
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;

   // open an output stream to make file of ascii nutples for ROOT
   ofstream nout("ntuple.ascii");
   if(!nout)
   {
     cout << "Cannot open output file.\n";
     return 1;
   }
	// output column names
	nout << "RunNumber"<<TAB<<"RunType"<< TAB<< "EventNumber" <<TAB<< "BufferSequenceNumber" 
			<<TAB<<"RealTimeLR"<<TAB<< "RealTimeHR"
			<<TAB<<"LrRampTimeAdc" <<TAB<<"HrRampTimeAdc"
			<<TAB<<"Mcp1TimeAdc"<<TAB<< "Mcp1PhAdc" <<TAB<<"Mcp2TimeAdc"<<TAB<<"Mcp2PhAdc"
			<<TAB<<"Mcp3TimeAdc"<<TAB<< "Mcp3PhAdc" <<TAB<<"Mcp4TimeAdc"<<TAB<<"Mcp4PhAdc"
	                <<TAB<<"nScaler1"<<TAB<<"nScaler2"<< TAB <<"nScaler3"
			<<TAB<<"CherenkovLatchADC" <<endl;

   int testcount=0;
	int preQuill = 7;
   for (;;) {
	for ( j=0; j<preQuill; j++) {
		in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		if (testcount < 100 ) cout << inIndexM << TAB << hex << inHexData << TAB << dec << inDecData << endl;
		testcount++;
		if ( inIndexM == -7 )  
		{ scalerPointer = inDecData;
		  if ( scalerPointer != 0) {
		    for ( k=0; k< scalerPointer; k++) {
		      in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
			if (testcount < 100 ) cout << inIndexM << TAB << hex << inHexData << TAB << dec << inDecData<<endl;
		      nScalerValue[k] = inDecData;
		    }
		  }
		}
		if ( inIndexM == -6 ) runType = inDecData;
		if ( inIndexM == -5 )  nRunNumber  = inDecData;
		if ( inIndexM == -4 ) realTimeLRc1 = inDecData;
		if ( inIndexM == -3 ) realTimeHRc1 = inDecData;
		if ( inIndexM == -2 ) { crateIDc1 = inDecData; bufferSequenceNumber++; }
		if ( inIndexM == -1 ) memoryPointer1 = inDecData;
	}
	// detect an EOF
	if ( in.eof() != 0 ) {
		cout << "Found end of file..." << endl;
		break;
	}
	nRealTimeLR1 = realTimeLRc1;
	nRealTimeHR1 = realTimeHRc1;
	
	if ( crateIDc1 != 4 ) cerr << "Found wrong camac crate id " << crateIDc1 << endl;
	if ( memoryPointer1 != 15876 ) cerr << "Found abnormal memoryPointer1 = " << memoryPointer1 << endl;
	for ( j=0; j<memoryPointer1; j++) in >> inIndexM >> hex >> data1H[j] >> dec >> data1D[j];


	for ( j=0; j<preQuill; j++) {
		in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		if ( inIndexM == -7 )  
		{ scalerPointer = inDecData;
		  if ( scalerPointer != 0) {
		    for ( k=0; k< scalerPointer; k++) {
		      in >> inIndexM >> hex >> inHexData >> dec >> inDecData;
		      nScalerValue[k] = inDecData;
		    }
		  }
		}
		if ( inIndexM == -6 ) runType = inDecData;
		if ( inIndexM == -5 ) nRunNumber = inDecData;
		if ( inIndexM == -4 ) realTimeLRc2 = inDecData;
		if ( inIndexM == -3 ) realTimeHRc2 = inDecData;
		if ( inIndexM == -2 ) crateIDc2 = inDecData;
		if ( inIndexM == -1 ) memoryPointer2 = inDecData;
	}
	if ( crateIDc2 != 5 ) cerr << "Found wrong camac crate id " << crateIDc2 << endl;
	if ( memoryPointer2 != 15876 ) cerr << "Found abnormal memoryPointer2 = " << memoryPointer2 << endl;
	for ( j=0; j<memoryPointer2; j++) in >> inIndexM >> hex >> data2H[j] >> dec >> data2D[j];

	memoryPointer = memoryPointer1;		/* assume pulser run */
	if ( memoryPointer2 > memoryPointer1 ) memoryPointer = memoryPointer2;

	//cout << "memoryPointer1 = " << memoryPointer1 << " memoryPointer2 = " << memoryPointer1 << endl;
	//cout << "crateIDc1 = " << crateIDc1 << " crapteIDc2 = " <<  crateIDc2 << endl;

	//for ( j=0; j<42; j++ ) cout << j << TAB << hex << data1H[j] << TAB << dec << data1D[j] 
	//				<< TAB << hex << data2H[j] << TAB << dec << data2D[j] << endl;

	lineCount = 0;
	ptr1LadcHdr = 0;
	ptr1OadcHdr1 = 17;
	ptr1OadcHdr2 = 19;
	ptr2LadcHdr = 0;
	ptr2OadcHdr1 = 17;
	ptr2OadcHdr2 = 19;
	memoryIndex1 = 0;	memoryIndex2 = 0;
      while  (  (memoryIndex1 < memoryPointer1 ) && (memoryIndex2 < memoryPointer2) )  {

//---------------------mark 1
/*
        cout << endl;
        cout << endl;
        cout << "At top of while memoryIndex1=" << memoryIndex1 << " memoryPointer1=" << memoryPointer1
                << " memoryIndex2=" << memoryIndex2 << " memoryPointer2=" << memoryPointer2 << endl;
        cout << "At top of while continued ptr1LadcHdr=" << ptr1LadcHdr << endl;
	for ( i=0; i<memoryPointer; i++ ) {
		cout << i << TAB << hex << data1H[i] << TAB << data2H[i] << dec << endl;
	}
	cout << endl;
 
 */
 
        offSet1 = 21;
        offSet2 = 21;
        for ( i=0; i<21; i++ ) {
                inHdata1[i] = 0;
                inDdata1[i] = 0;
        }
 
        for ( i=0; i<21; i++ ) {
                inHdata1[i] = data1H[ptr1LadcHdr + i ];
                inDdata1[i] = data1D[ptr1LadcHdr + i ];
                //cout << "i="<<i<< TAB << hex << "inHdata1[i]=" << inHdata1[i] << dec << endl;
        }
 
        flag1=true;
        flag2=true;
 
/*---------------------------------------------------------------*/
       if ( inHdata1[0] == 0x8005 ) {
                offSet1 = 17;
                LadcHeader1counter++;
        } else {
                cout << "Failed to find 0x8005 header in first memory..so exit" << endl;
                cout << " inHdata1[0] = " << hex << inHdata1[0] << dec <<endl;
                cout << " memoryIndex1=" << memoryIndex1 << " memoryPointer1=" << memoryPointer1
                << " memoryIndex2=" << memoryIndex2 << " memoryPointer2=" << memoryPointer2 << endl;
                for ( i=0; i<21; i++ ) {
                        cout << "i="<<i<< TAB << hex << "inHdata1[i]=" << inHdata1[i] << dec ;
                        cout <<           TAB << hex << "inHdata2[i]=" << inHdata2[i] << dec << endl;
                }
                cout << "Failed to find 0x8005 header in first memory..so exit" << endl;
                cout << "End of dump..." << endl;
                //return 1;
		break;
        }
        evCountHdr1 = 0;
        if ( inHdata1[17] == 0x8801 && inHdata1[19] == 0x8802 ){
                //cout << "Found case 1 " << endl;
                correctedOadcHeader1 = 0x8801;
                correctedOadcData1   = inHdata1[18];
                correctedOadcHeader2 = 0x8802;
                correctedOadcData2   = inHdata1[20];
                offSet1 = 21;
                evCountHdr1=2;
        }
        if ( inHdata1[17] == 0x8801 && inHdata1[19] != 0x8802 ){
                //cout << "Found case 2 " << endl;
                correctedOadcHeader1 = 0x8801;
                correctedOadcData1   = inHdata1[18];
                correctedOadcHeader2 = 0x8802;
                correctedOadcData2   = 0;
                offSet1 = 19;
                evCountHdr1=1;
		missingOrtecHeaderCount[1]++;
        }
        if ( inHdata1[17] == 0x8802 && inHdata1[19] != 0x8802 ){
                //cout << "Found case 3 " << endl;
                correctedOadcHeader1 = 0x8801;
                correctedOadcData1   = 0;
                correctedOadcHeader2 = 0x8802;
                correctedOadcData2   = inHdata1[18];
                offSet1 = 19;
                evCountHdr1=1;
		missingOrtecHeaderCount[0]++;
        }
        if ( evCountHdr1 == 0 ) {
                //cout << "Found case 4 " << endl;
                correctedOadcHeader1 = 0x8801;
                correctedOadcData1   = 0;
                correctedOadcHeader2 = 0x8802;
                correctedOadcData2   = 0;
                offSet1 = 17;
		missingOrtecHeaderCount[0]++;
		missingOrtecHeaderCount[1]++;
        }
 
        inHdata1[17]=correctedOadcHeader1;
        inHdata1[18]=correctedOadcData1;
        inHdata1[19]=correctedOadcHeader2;
        inHdata1[20]=correctedOadcData2;
 
        //cout << "At end of tests offSet1=" << offSet1 << endl;
 
        ptr1LadcHdr = ptr1LadcHdr + offSet1;
 
        //cout << "After Corrections..." << endl;
        //for ( i=0; i<21; i++ ) {
        //      cout << "i="<<i<< TAB << hex << "inHdata1[i]=" << inHdata1[i] << dec << endl;
        //}
 
// now 2nd memory...
 
        offSet2=21;
 
        flag3=true;
        flag4=true;
 
        for ( i=0; i<21; i++ ) {
                inHdata2[i] = 0;
                inDdata2[i] = 0;
        }
                                                                                                                       
        for ( i=0; i<21; i++ ) {
                inHdata2[i] = data2H[ptr2LadcHdr + i ];
                inDdata2[i] = data2D[ptr2LadcHdr + i ];
                //cout << "i="<<i<< TAB << hex << "inHdata2[i]=" << inHdata2[i] << dec << endl;
        }
 
//--------------------------new
        if ( inHdata2[0] == 0x8006 ) {
                offSet2 = 17;
                LadcHeader2counter++;
        } else {
                cout << "Failed to find 0x8006 header so exit" << endl;
                cout << " inHdata2[0] = " << hex << inHdata2[0] << dec <<endl;
                cout << " memoryIndex1=" << memoryIndex1 << " memoryPointer1=" << memoryPointer1
                << " memoryIndex2=" << memoryIndex2 << " memoryPointer2=" << memoryPointer2 << endl;
        	for ( i=0; i<21; i++ ) {
                	cout << "i="<<i<< TAB << hex << "inHdata1[i]=" << inHdata1[i] << dec ;
                	cout <<           TAB << hex << "inHdata2[i]=" << inHdata2[i] << dec << endl;
        	}
		cout << "End of dump..." << endl;
                return 1;
        }
        evCountHdr2 = 0;
        if ( inHdata2[17] == 0x8803 && inHdata2[19] == 0x8804 ){
                //cout << "Found case 1 " << endl;
                correctedOadcHeader3 = 0x8803;
                correctedOadcData3   = inHdata2[18];
                correctedOadcHeader4 = 0x8804;
                correctedOadcData4   = inHdata2[20];
                offSet2 = 21;
                evCountHdr2=2;
        }
        if ( inHdata2[17] == 0x8803 && inHdata2[19] != 0x8804 ){
                //cout << "Found case 2 " << endl;
                correctedOadcHeader3 = 0x8803;
                correctedOadcData3   = inHdata2[18];
                correctedOadcHeader4 = 0x8804;
                correctedOadcData4   = 0;
                offSet2 = 19;
                evCountHdr2=1;
		missingOrtecHeaderCount[2]++;
        }
        if ( inHdata2[17] == 0x8804 && inHdata2[19] != 0x8804 ){
                //cout << "Found case 3 " << endl;
                correctedOadcHeader3 = 0x8803;
                correctedOadcData3   = 0;
                correctedOadcHeader4 = 0x8804;
                correctedOadcData4   = inHdata2[18];
                offSet2 = 19;
                evCountHdr2=1;
		missingOrtecHeaderCount[3]++;
        }
        if ( evCountHdr2 == 0 ) {
                //cout << "Found case 4 " << endl;
                correctedOadcHeader3 = 0x8803;
                correctedOadcData3   = 0;
                correctedOadcHeader4 = 0x8804;
                correctedOadcData4   = 0;
                offSet2 = 17;
		missingOrtecHeaderCount[2]++;
		missingOrtecHeaderCount[3]++;
        }
 
 
        inHdata2[17]=correctedOadcHeader3;
        inHdata2[18]=correctedOadcData3;
        inHdata2[19]=correctedOadcHeader4;
        inHdata2[20]=correctedOadcData4;
                                                                                                                                                                   
        //cout << "After All Corrections..." << endl;
        //for ( i=0; i<21; i++ ) {
        //        cout << "i="<<i<< TAB << hex << "inHdata1[i]=" << inHdata1[i]
        //                <<  TAB << hex << "inHdata2[i]=" << inHdata2[i] << dec << endl;
        //}
 


//-------- mark 2
 
	ptr2LadcHdr = ptr2LadcHdr + offSet2;
	ptr2OadcHdr1= ptr2OadcHdr1 + offSet2;
	ptr2OadcHdr2= ptr2OadcHdr2 + offSet2;
	memoryIndex2 = memoryIndex2 + offSet2;


		int LeCroyADCheader1 = 0x8004;
		    LeCroyADCheader1 = 0x8005;	/* did this change */
		int LeCroyADCheader2 = 0x8006;

		if ( (inHdata1[ADCLOC] != LeCroyADCheader1) && (inHdata2[ADCLOC] != LeCroyADCheader2)) { /* lecroy 4300 ADC header */
			cout << "at line = "<<  lineCount <<  " ADC Alignment error...print inHdata" << endl;
			cout << "at line = " << lineCount << TAB << hex << inHdata1[ADCLOC] << TAB << inHdata2[ADCLOC] << endl;
			cout << dec << endl;
			return 1;
		} else {
			countADCheader1++;
			countADCheader2++;
		}

                if ( (inHdata1[AD1LOC] != 0x8801) ) {
                        cout << "ad114 Alignment error on 8801..." << endl;
			nADC1time = 0;
                } else {
                        countAD114header1++;
                        nADC1time = inHdata1[AD1LOC+1];
                }

                if ( (inHdata2[AD1LOC] != 0x8803) ) {
                        cout << "ad114 Alignment error on 8803..." << endl;
			nADC3time = 0;
                } else {
                        countAD114header3++;
                        nADC3time = inHdata2[AD1LOC+1];
                }

                if ( (inHdata1[AD2LOC] != 0x8802) ) {
                        cout << "ad114 Alignment error on 8802..." << endl;
			nADC2time = 0;
                } else {
                        countAD114header2++;
                        nADC2time = inHdata1[AD2LOC+1];
                }

                if ( (inHdata2[AD2LOC] != 0x8804) ) {
                        cout << "ad114 Alignment error on 8804..." << endl;
			nADC4time = 0;
                } else {
                        countAD114header4++;
                        nADC4time = inHdata2[AD2LOC+1];
                }

		eventCount++;
		for ( i=0; i<16; i++ ) {
			lAdc1ChAddr[i] = getbits(inHdata1[ADCLOC+1+i],15,5);
			lAdc1ChData[i] = getbits(inHdata1[ADCLOC+1+i],10,10);
			lAdc2ChAddr[i] = getbits(inHdata2[ADCLOC+1+i],15,5);
			lAdc2ChData[i] = getbits(inHdata2[ADCLOC+1+i],10,10);
		}
		
			hADCtime1->update( (float) inHdata1[AD1LOC+1] );
			hADCtime2->update( (float) inHdata1[AD2LOC+1] );
			hADCtime3->update( (float) inHdata2[AD1LOC+1] );
			hADCtime4->update( (float) inHdata2[AD2LOC+1] );
		hADCpm1->update( (float) lAdc1ChData[2] );
		hADCpm2->update( (float) lAdc1ChData[3] );
		hADCpm3->update( (float) lAdc2ChData[2] );
		hADCpm4->update( (float) lAdc2ChData[3] );
		slowRampValue = lAdc1ChData[0];
		fastRampValue = lAdc1ChData[1];
		nRampTimeAdc = slowRampValue;			/* choose only one for current ntuple */
		hSlowRamp->update( (float) slowRampValue );
		hFastRamp->update( (float) fastRampValue );
		if ( eventCount < 10 ) {
			for ( i=0; i<16; i++ ) {
				cout << " " << lAdc1ChAddr[i] << ":" 
				<< " "      << lAdc1ChData[i]
				<< TAB      << lAdc2ChAddr[i] << ":"
				<< " "      << lAdc2ChData[i] << endl;
			}
			cout << endl;
			cout << "nADC1time="<<nADC1time << " ";
			cout << "nADC2time="<<nADC2time << " ";
			cout << "nADC3time="<<nADC3time << " ";
			cout << "nADC4time="<<nADC4time << " ";
			cout << endl;
		}
		// begin building ntuple to outup
		nADC1ph = lAdc1ChData[2];
		nADC2ph = lAdc1ChData[3];
		nADC3ph = lAdc2ChData[2];
		nADC4ph = lAdc2ChData[3];
		nEventCount = eventCount;
		nout << nRunNumber << TAB<< runType<<TAB << nEventCount <<TAB<< bufferSequenceNumber 
		<<TAB<< nRealTimeLR1 <<TAB<< nRealTimeHR1 <<TAB
		<<TAB<< slowRampValue << TAB <<  fastRampValue
		<<TAB<< nADC1time <<TAB<<  nADC1ph <<TAB<< nADC2time <<TAB<< nADC2ph
		<<TAB<< nADC3time <<TAB<<  nADC3ph <<TAB<< nADC4time <<TAB<< nADC4ph
		<<TAB<< nScalerValue[1] <<TAB<< nScalerValue[2] <<TAB<< nScalerValue[3] 
		<<TAB<< nCherenkovADC
		                                        << endl;
     } // end of event build loop
   } // end of forever loop

	// output histograms.
	hADCtime1->printLong();
	hADCtime2->printLong();
	hADCtime3->printLong();
	hADCtime4->printLong();
	hADCpm1->printLong();
	hADCpm2->printLong();
	hADCpm3->printLong();
	hADCpm4->printLong();
	hSlowRamp->printLong();
	hFastRamp->printLong();

	cout << endl;
	cout << "Found " << lineCount << " lines."  << endl;
	cout << "eventCount      = " << eventCount << endl;
	cout << "errorType1count = " << errorType1count << endl;
	cout << "countADCheader1 = " << countADCheader1 << endl;
	cout << "countADCheader2 = " << countADCheader2 << endl;
	cout << "countAD114header1 = " << countAD114header1 << endl;
	cout << "countAD114header2 = " << countAD114header2 << endl;
	cout << "ntupleCount     = " << ntupleCount << endl;
	cout << "ADCtime1 count/mean/stdev = " << hADCtime1->get_sumIn() << TAB << hADCtime1->mean() << TAB << hADCtime1->stdev() << endl;
	cout << "ADCtime2 count/mean/stdev = " << hADCtime2->get_sumIn() << TAB << hADCtime2->mean() << TAB << hADCtime2->stdev() << endl;
	cout << "ADCtime3 count/mean/stdev = " << hADCtime3->get_sumIn() << TAB << hADCtime3->mean() << TAB << hADCtime3->stdev() << endl;
	cout << "ADCtime4 count/mean/stdev = " << hADCtime4->get_sumIn() << TAB << hADCtime4->mean() << TAB << hADCtime4->stdev() << endl;
	cout << "Missing Ortec Header counts: ";
	for ( i=0;i<4;i++) cout << missingOrtecHeaderCount[i] << TAB;
	cout << endl;

	nout.close();

	return 0;

}
