#include <iostream>
#include <iomanip>
#include "histogram.h"
#include <string>

#define TAB '\t'

using namespace std;

int main(int argc, char** argv)	{

	int tupleCount=0;
	float talim = 0.0, tblim=0.0; // run_047
	float qalim = 3000.0, qblim=3020.0; // run_047
	float t1mean = 7674.0;
	float t2mean = 6891.0;
	float q1mean = 392.0;
	float q2mean = 377.0;

	int adcTime1, adcTime2, adcCharge1, adcCharge2;
	double buffTime1, buffTime2, fixedDelay, pulserPeriod;
	int runNumber, eventNumber;

	// use 1st row of the tuple to set histogram scale
	cin >> runNumber >> eventNumber 
		>> buffTime1 >> buffTime2 >> fixedDelay >> pulserPeriod
		>> adcTime1 >> adcCharge1 >> adcTime2 >> adcCharge2;
	int offset = 1;
	t1mean = adcTime1 - offset;
	t2mean = adcTime2 - offset;
	q1mean = adcCharge1;
	q2mean - adcCharge2;
	

	talim = t1mean - 10.0;
	tblim = t1mean + 10.0;
	histogram *hADCtime1 = new histogram(talim, tblim, "h time ADC 1 data ");
	histogram *hADCtime1a= new histogram(talim, tblim, "h time ADC 1a data ");
	histogram *hADCtime1b= new histogram(talim, tblim, "h time ADC 1b data ");
	//t2mean = 5299;
	double width = 10.0;
	talim = t2mean - width;
        tblim = t2mean + width;

	histogram *hADCtime2 = new histogram(talim, tblim, "h time ADC 2 data ");
	qalim = q1mean - 10.0;
	qblim = q1mean + 10.0;
	histogram *hADCcharge1 = new histogram(qalim, qblim,  "h charge ADC 1 data ");
	
	qalim = q2mean - 10.0;
	qblim = q2mean + 10.0;
	histogram *hADCcharge2 = new histogram(qalim, qblim,  "h charge ADC 2 data ");

	histogram *hReadTime = new histogram( 0.0, 40.0, "h Read Times" );
	histogram *hReadTimeDelta = new histogram( 0.0, 0.004, "h Read Time Delta");

/*
	getline(cin,titleString);
	cout << "Title: " << titleString << endl;
	cout << "DEBUG:\tLine\tlineID\thdata\tddata" << endl;
 */

   for (;;) {

	cin >> runNumber >> eventNumber 
		>> buffTime1 >> buffTime2 >> fixedDelay >> pulserPeriod
		>> adcTime1 >> adcCharge1 >> adcTime2 >> adcCharge2;

	// detect an EOF
        if ( cin.eof() != 0 ) {
                cout << "Found end of file..." << endl;
                break;
        }

		tupleCount++;
	
		hADCtime1->update( (float) adcTime1 );
		hADCcharge1->update( (float) adcCharge1 );
		hADCtime2->update( (float) adcTime2 );
		hADCcharge2->update( (float) adcCharge2 );

		hReadTime->update( (float) buffTime1 );
		hReadTimeDelta->update( (float) (buffTime2-buffTime1) );
		double readTimeDelta = buffTime2-buffTime1;

		if ( eventNumber%2 == 0  )
			hADCtime1a->update( (float) adcTime1 );
		if ( eventNumber%2 == 1  )
			hADCtime1b->update( (float) adcTime1 );

   } // end of forever loop

	// output histograms.
	cout << "Found " << tupleCount  << " lines."  << endl;

        hADCtime1->printLong();
        hADCtime1a->printLong();
        hADCtime1b->printLong();
        hADCtime2->printLong();
        hADCcharge1->printLong();
        hADCcharge2->printLong();
	hReadTime->printLong();
	hReadTimeDelta->printLong();
	cout << "Found " << tupleCount << " ntuple rows."<< endl;
	cout << "Last reported buffer read time is " << buffTime2 << endl;
	cout << "Estimate average rate = "<< hADCtime1->get_sumIn()/buffTime2 << endl;
	cout << "hADCtime1 mean = " << hADCtime1->mean() 
		<< " stdev = " << hADCtime1->stdev() 
		<< " SumIn = " << hADCtime1->get_sumIn()<< endl;
	cout << "hADCtime2 mean = " << hADCtime2->mean() 
		<< " stdev = " << hADCtime2->stdev() 
		<< " SumIn = " << hADCtime2->get_sumIn() << endl;

	return 0;

}
