#include "ieee_fun_types.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define MILLION 1000000

unsigned  getbits( unsigned x, unsigned p, unsigned n) 
{
    /* get n bits from position p */
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
  /*int ret;	*/	/* return for CAMAC command*/
  int mPointer=0;	/* holder for FERA memory pointer returned */
  int lam=0;
  int ext;
  int branch=18;
  int crate1=2;
  /*
  int crate2=4;
   */
  int crate,slot,subad,function,temp,qres;
  int iloop=0;  

  /* unsigned long CDATA,CDATA0,CDATA1,CDATA2,CDATA3; */

  int return_status = CAM_S_SUCCESS;
  /* data array returned by Camac Controler */
  /* unsigned short IntArray[10000]; 
   */
  unsigned short dataw[2]={0,0};
  unsigned short data16[32768];
  /* Jorway spec say max 16bit word dma transfer is 16100 */
  int cb[3];	/* camac control block 0=request_repeat_count 1=result_repeat_count
						2=lam id(not used)    3=dma type 0=Q-stop 1=single_word
                         */
  int i=0;
  /*
  unsigned short RAW;
  int numNoReads=25;
  float pulserDelay=0.0, pulserPeriod=0.0;
   */
  
  /* stuff for time and date 
  struct timeval tpstart;
  struct timeval tpend;
  int timedif; */
  
 	
  /***************** OPEN DATA FILE ********************/

	/* File to save data */
    FILE *data_file;
    char file[20] = ("data/run_001.txt");
    char ctemp[4];
    int r;
    int run;

  /* get configuration information from user or a <redirected file. */
/*   printf("Enter Run Number:  ");
    scanf("%003i",&run);
 */
	run = 0;	/* force run 000 */
    printf("run = %d\n", run);
    sprintf( &ctemp[0], "%03i", run);
    for (r = 0; r<3; ++r) file[r+9]=ctemp[r];
    printf("file name = %s\n", file); 

  /* Truncate to zero length or create file for writing ascii data output*/
    data_file = fopen(file,"w");
    if ( data_file == NULL ) {
      printf("Failed to open an output file to write data!\n");
      return 2;}

/*
    printf("Enter Number of NoReads allowed: ");
    scanf("%d",&numNoReads);
    printf("Enter pulserDelay: ");
    scanf("%f",&pulserDelay);
    printf("Enter pulserPeriod: ");
    scanf("%f",&pulserPeriod);

    printf("User requested numNoReads = %d\n", numNoReads);
    printf("User requested pulserDelay = %f\n", pulserDelay);
    printf("User requested pulserPeriod = %f\n", pulserPeriod);

    printf("TitleLine: CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);
    fprintf(data_file,"CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", 
    run, numNoReads, pulserDelay, pulserPeriod);

    */


 /****************** OPEN Jorway CAMAC interface **********************/

    printf ("\n Opening Jorway411 branch highway");

    if ((return_status = cdchn(branch, 1, 0)) !=  CAM_S_SUCCESS)  {
      printf("Error opening branch=%d\n",branch);
      exit(1);
    };

    ccctype(branch,0,1);  /* parallel - Jor 73A is considered parallel */

 /**************************** Initialize CAMAC **************************/

    printf("\n Initializing CAMAC\n");
    slot=2; subad=0; 

  /* encode the branch, crate, slot, 
     and subad arguments into ext */
    cdreg(&ext,branch,crate,slot,subad);
  
  /* crate clear */
    cccc(ext);
  /* crate initialize */
    cccz(ext);
  /* remove crate inhibit */
    ccci(ext,0);

  function=0;

  /****************** SET TRIGGER INHIBIT WITH 2323 GATE GENERATOR ***********************/

  printf("\n Set trigger inhibit");

  slot=18;

  /* Clear module */

    subad=1; 
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x2000;    /* Set 2323 channel B into latch mode */    
    cssa(17,ext,dataw,&qres);
    cssa(25,ext,dataw,&qres);    /* Start channel B inhibit  */


  /****************** SET UP 1st Ortec AD411 ADC ***********************/
  /*	0x5F00 = 1001 1111 0000 0000

	B16 =0 => Overflow-suppresion
	B15
	B14
	B13 =1 => Singles mode
	---
	B12 =1 => Master Gate ignored
	B11 =1 => Local Gate ignored
	B10 =1 => Camac readout enabled
	B9  =0 => Zero-suppression ? ? ?  
	---
	b1 to b8 => Virt station number
   */
 
    printf("\n Initializing ADC1");

    slot=8; 

  /* Clear module */

    subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);
    printf(" (using slot=%d) ",slot);

  /* Write to control register and read back  */
    dataw[0]=0x1801;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC1 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 LLD: 0x%x", temp & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC1 ULD: 0x%x", dataw[0] & 0xFF);	
    printf("\n");

  /****************** SET UP 2nd Ortec AD411 ADC ***********************/
 
    printf("\n Initializing ADC2");

    slot=3;

  /* Clear module */
    subad=0; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);
    printf(" (using slot=%d) ",slot);

  /* Write to control register and read back  */
    dataw[0]=0x1402;    
    cssa(16,ext,dataw,&qres);  /* Using FERA */

    cssa(0,ext,&dataw[0],&qres);  
    printf("\n ADC2 Control Register: 0x%x", dataw[0]);	

  /* Read lower level discriminator setting */
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 LLD: 0x%x", dataw[0] & 0xFF);	

  /* Read upper level discriminator setting */
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(1,ext,&dataw[0],&qres);  
    printf("\n ADC2 ULD: 0x%x", dataw[0] & 0xFF);	
    printf("\n");

  /***************** SET UP the LeCroy 4302 FERA memory ********************/

    printf("\n Initializing 4302 buffer memory");

    slot=14; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/
    printf(" (using slot=%d) ",slot);

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(26,ext,dataw,&qres);    /* Set 4302 to enable LAM*/

    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address */

    for(iloop=0; iloop<16385; iloop++){
      cssa(16,ext,dataw,&qres);}    /* Write 0x0 to all memory addresses */

    cssa(17,ext,dataw,&qres);    /* Set 4302 to first memory address again */

    cssa(10,ext,dataw,&qres);	/* Test and clear the LAM on 4302 */
    printf("\n 4302 Test and clear LAM qres = %d ", qres);

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);    /* Set 4302 ECL mode enabled */

    cssa(1,ext,&dataw[0],&qres);    /* Read mode */
    printf("\n 4302 buffer mode is = %X",dataw[0]);

    printf("\n");

  /****************** SET UP Lecroy 4300B  ADC **********************/

    printf("\n Initializing 4300 ADC");

    slot=5; 

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres); 
    printf(" (using slot=%d) ",slot);

    dataw[0]=0x0404;
    dataw[0]=0x0604;
    /* dataw[0]=0x0704; */
    cssa(16,ext,dataw,&qres); 

	/* set pedestals all to zero */
	for (i=0; i<16; i++) {
		subad = i;
		cdreg(&ext,branch,crate1,slot,subad);
		dataw[0]=0x0;
		cssa(17,ext,dataw,&qres);
	}


    cssa(0,ext,&dataw[0],&qres); 
    printf("\n 4300 control register = %X",dataw[0]);

    printf("\n");

  /****************** SET UP Lecroy 3377 TDC **********************/

    printf("\n Initializing Lecroy 3377 TDC");

    slot=6; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(24,ext,dataw,&qres);   /* Disable acquisition*/
    printf(" (using slot=%d) ",slot);

    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);   /* Initial clear */
    cssa(30,ext,dataw,&qres);  /* Enable programming */
    cssa(25,ext,dataw,&qres);  /* Begin programming */
    qres=0;
    while(qres!=1){cssa(13,ext,dataw,&qres);} /* Test for programming done */

    cssa(9,ext,dataw,&qres);   /* Initial clear */

    cssa(1,ext,&dataw[0],&qres);   
    printf("\n Mode = %d",(dataw[0]&&0xC000)>>14);

    dataw[0]=0x0803;    /* Header mode; .5 nsec; FERA; leading edge */
    cssa(17,ext,dataw,&qres);   /* Control register 0 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 0 = %X",dataw[0]);

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x02FF;        /* Clock unit=100nsec; delays 1.5 microsec */
    cssa(17,ext,dataw,&qres);   /* Control register 1 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 1 = %X",dataw[0]);

    subad=2;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x03D1;            /* 488 nsec full scale  */
    cssa(17,ext,dataw,&qres);   /* Control register 2 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 2 = %X",dataw[0]);

    subad=3;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x000F;            /* REQ delay of 30 microsec */
    cssa(17,ext,dataw,&qres);   /* Control register 3 write */
    cssa(1,ext,&dataw[0],&qres);   
    printf("\n 3377 control register 3 = %X",dataw[0]);

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(26,ext,dataw,&qres);   /* Enable acquisition */

    printf("\n\n***** End of setup and configuration ******\n");





  /***************************************************************/
  /************************ START EVENT LOOP *********************/
  /***************************************************************/

    printf("\n Release trigger inhibit");

    slot=18;

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(9,ext,dataw,&qres);    /* Stop channel B inhibit  */


/*
    printf("\n Sleeping for 20 seconds to simulate spill...\n");
    fprintf(stderr,"\n Sleeping for 20 seconds to simulate spill...\n");
    sleep(20);
 */

    while ( lam == 0 ) {
       slot=14;subad=0;function=8;	/* test lam status */
       cdreg(&ext,branch,crate1,slot,subad);
       cssa(function,ext,dataw,&qres);
       lam = qres;
       if ( lam == 1 ) break;
       fprintf(stderr, " Waiting on LAM, sleep for 1 sec\n");
       sleep(1);
    }


  /* set trigger inhibit */

    printf("\n Set trigger inhibit");

    slot=18;
    subad=1; 
    cdreg(&ext,branch,crate1,slot,subad);
    cssa(25,ext,dataw,&qres);    /* Start channel B inhibit  */

    /* Set 4302 to CAMAC mode*/

    slot=14; 

    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x1;
    cssa(17,ext,dataw,&qres);    /* Set 4302 to CAMAC mode*/

    /* Read 4302 memory address */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(1,ext,&dataw[0],&qres);
    printf("\n Current pointer for 4302 = %X %d",dataw[0],dataw[0]);
    fprintf(stderr, "\n Current pointer for 4302 = %X %d",dataw[0],dataw[0]);
    mPointer = dataw[0];	/* save the memory point to set dma size */

    /* Set 4302 current memory address to 0 */
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x0;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */

    for ( i=0; i< 32768; i++) data16[i]=0;	/* clear buffer to receive data from dma */

    /* do a 1 word read or dma of 4302 memory */

    int top = 0;
    if ( 1 == 0 ) {
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cssa(0, ext, &dataw[0], &qres);
	printf("1st word in memory is %X %d \n", dataw[0], dataw[0]);
    } else {
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	if (mPointer <= 16100 ) {
		cb[0]=mPointer; cb[1]=0; cb[2]=0; cb[3]=0;
	} else {
		cb[0]=16100; cb[1]=0; cb[2]=0; cb[3]=0;
	}
	csubc(0, ext, data16, cb);
	printf("\n dma returns cb[1]=%d", cb[1]);
        fprintf(stderr, "1st dma complete cb = %d %d %d %d\n", cb[0],cb[1],cb[2],cb[3]);
	top = cb[1];
	if (top > 16384 ) top = 16384;
	for ( i=0; i<top+1; i++) {
		if ( (data16[i] & 0x8000) == 0x8000 ) {
			/* printf("\n i=%d data16[%d]= %x %d possible header.", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d header", i, data16[i],data16[i]);
		}
		else {
			/* printf("\n i=%d data16[%d]= %x %d", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d", i,data16[i],data16[i]);
		}
		fprintf(data_file, "%d %x %d\n", i,data16[i],data16[i]);
	}
    }

    if ( top == 16100 ) {
	/* attempt to readout remainder of buffer */
       /* Set 4302 current memory address to 0 */
       subad=0;
       cdreg(&ext,branch,crate1,slot,subad);
       dataw[0]=16100;
       cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to end of last dma */

        for ( i=0; i< 32768; i++) data16[i]=0;	/* clear buffer to receive data from dma */
	subad=0;
	cdreg(&ext,branch,crate1,slot,subad);
	cb[0]=384; cb[1]=0; cb[2]=0; cb[3]=0;
	csubc(0, ext, data16, cb);
	printf("\n dma returns cb[1]=%d", cb[1]);
        fprintf(stderr, "2nd dma complete cb = %d %d %d %d\n", cb[0],cb[1],cb[2],cb[3]);
	int top = cb[1];
	if (top > 16384 ) top = 16384;

	for ( i=0; i<top+1; i++) {
		if ( (data16[i] & 0x8000) == 0x8000 ) {
			/* printf("\n i=%d data16[%d]= %x %d possible header.", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d header", i, data16[i],data16[i]);
		}
		else {
			/* printf("\n i=%d data16[%d]= %x %d", i,i,data16[i],data16[i]); */
			printf("\n %d %x %d", i,data16[i],data16[i]);
		}
		fprintf(data_file, "%d %x %d\n", i,data16[i],data16[i]);
	} /* end of for ( */

   } /* end of if ( top == 16100 */

    /* Set 4302 current memory address to 0 */
    
    subad=0;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=16100;
    cssa(17,ext,dataw,&qres);    /* Set 4302 current memory address to 0 */

    /* Set 4302 ECL mode enabled */
    
    subad=1;
    cdreg(&ext,branch,crate1,slot,subad);
    dataw[0]=0x3;
    cssa(17,ext,dataw,&qres);     /* Set 4302 ECL mode enabled */


/* possible end of polling loop */

  /***************************************************************/
  /************************ END EVENT LOOP *********************/
  /***************************************************************/

    printf("\n\n***** End of DAQ *****\n\n");

    return 0;
}
