#include <xx_usb.h>
#include <stdio.h>

// needed to get date/time at micro-second procission
#include <sys/time.h>
#define MILLION 1000000
#include <unistd.h>

#include <unistd.h>
// function to ask for process to sleep for integral number of seconds
//unsigned int sleep(unsigned int seconds);



unsigned  getbits( unsigned x, unsigned p, unsigned n) /* get n bits from position p */
{
	return  (( x >> (p+1-n)) & ~(~0 << n));
}

int main()
{
	long data;		// used when reading from camac registers
	int ret;		// return for CAMAC command
	int Q;			// CAMAC Q return
	int X;			// CAMAC X return
	int N;
	int A;
	int F;
	unsigned long CDATA;
	// places to hold configuration data for Lecroy 3377
	unsigned long CDATA0;
	unsigned long CDATA1;
	unsigned long CDATA2;
	unsigned long CDATA3;
	int i;			// loop variable
	unsigned short IntArray[10000];	// data array returned by Camac Controler
	unsigned short DATA;
	unsigned short RAW;
	int numNoReads=25;
	float pulserDelay=0.0, pulserPeriod=0.0;
	
// stuff for time and date
	struct timeval tpstart;
	struct timeval tpend;
	int timedif;


	// *****************************************************
	// ****************** OPEN CC-USB **********************
	// *****************************************************

	char* serial = "CC0028";    			// Serial number of CC_USB
	usb_dev_handle *udev;       			// Device Handle 

	xxusb_device_type *devices;

	// only need if you do not know the serial number
	//short ndevice = xxusb_devices_find( devices );
	//printf("ndevice = %d\n", ndevice);
	
	// Test Start
	printf("Test_8 start\n");
	
	// Open Device and get handle
	udev = xxusb_serial_open(serial);  
	
	// Make sure CC_USB opened OK
	if(!udev)
	  {
	    printf ("\n\nFailedto Open CC_USB %s\n\n",serial);
	    return 1;
	  }
	
	printf ("\n\n CC_USB %s opened \n\n",serial);
	


	// *****************************************************
	// ***************** OPEN DATA FILE ********************
	// *****************************************************

	FILE *data_file;
	char file[20] = ("data/run_001.txt");	// File to save data
	char ctemp[4];
	int r;
	int run;

// get configuration information from user or a <redirected file.
	printf("Enter Run Number:  ");
	scanf("%003i",&run);
	printf("run = %d\n", run);
	sprintf( &ctemp[0], "%003i", run);
	for (r = 0; r<3; ++r) file[r+9]=ctemp[r];
	printf("file name = %s\n", file);
	// Truncate to zero length or create file for writing ascii data output
	data_file = fopen(file,"w");
	if ( data_file == NULL ) {
		printf("Failed to open an output file to write data!\n");
		return 2;
	}

	printf("Enter Number of NoReads allowed: ");
	scanf("%d",&numNoReads);
	printf("Enter pulserDelay: ");
	scanf("%f",&pulserDelay);
	printf("Enter pulserPeriod: ");
	scanf("%f",&pulserPeriod);

	printf("User requested numNoReads = %d\n", numNoReads);
	printf("User requested pulserDelay = %f\n", pulserDelay);
	printf("User requested pulserPeriod = %f\n", pulserPeriod);


	printf("TitleLine: CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", run, numNoReads, pulserDelay, pulserPeriod);
	fprintf(data_file,"CC-USB data file runNumb=%d numNoReads=%d pulserDelay=%f pulserPeriod=%f \n", run, numNoReads, pulserDelay, pulserPeriod);

	sleep(2);

	CAMAC_I(udev, 1);
	CAMAC_Z(udev);					// initialize camac
	CAMAC_C(udev);

	printf("*****************************************************\n");
	printf("***************** SET UP CC-USB *********************\n");
	printf("*****************************************************\n");

	ret = CAMAC_register_read(udev, 0x0, &data);	// read firmware ID
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Firmware ID: 0x%x\n", data);		// write firmware ID to screen

	// write to Global Mode Register
	ret = CAMAC_register_write(udev, 0x1, 0x0);	// Set buffer size to 4k BuufOpt 
							// in Global Mode register
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x1, &data);	// read global mode
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Global Mode: 0x%x\n", data);		// write Global Mode to screen

	ret = CAMAC_register_read(udev, 0x2, &data);	// read delay register
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Delay Register: 0x%x\n", data);		// write delay register to screen

	ret = CAMAC_register_read(udev, 0x3, &data);	// read scalar readout control
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Scalar Readout Control: 0x%x\n", data);	// write delay register to screen

	ret = CAMAC_register_write(udev, 0x4, 0x1402);	// O1 -USB TRIGGER, O2 -DGG A, O3 -DGG B
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x4, &data);		
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("LED: 0x%x\n", data);			// write to screen

	ret = CAMAC_register_write(udev, 0x5, 0x18A3);	// O1 - DGG A, O2 - DGG B, O3 - DGG B, 
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x5, &data);		
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
 	printf("NIM Outputs: 0x%x\n", data);		// write to screen

	ret = CAMAC_register_write(udev, 0x6, 0x30300000);	// SCLR A - DISABLE, 
								// SCLR B - DISABLE, 
								// DGG A - I3, DGG B - I3
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x6, &data);				
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Device Selector: 0x%x\n", data);	// write to screen

	ret = CAMAC_DGG(udev, 0, 3, 1, 1, 1, 0, 0);	// 10ns gate, 10ns delay
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x7, &data);			
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("DGG A: 0x%x\n", data);			// write to screen

	ret = CAMAC_DGG(udev, 1, 3, 2, 1, 1, 0, 0);	// 10ns gate, 10ns delay
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x8, &data);			
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("DGG B: 0x%x\n", data);			// write to screen

	ret = CAMAC_register_write(udev, 0xD, 0x0);	// DGG A - not availible, DGG B - 0us
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0xD, &data);				
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Extended Delays: 0x%x\n", data);	// write to screen

	//ret = CAMAC_register_write(udev, 0x9, 0x8);	// lam mask NIM I1,
	//ret = CAMAC_register_write(udev, 0x9, 0x200);	// lam mask NIM I1, n=10
	ret = CAMAC_register_write(udev, 0x9, 0x00);	// lam mask NIM I1, 
	//ret = CAMAC_register_write(udev, 0x9, 0x10);	// lam mask NIM I1, n=5
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0x9, &data);				
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf ("Lam Mask: 0x%x\n", data);		// write to screen

	//ret = CAMAC_register_write(udev, 0xE, 0x0);	// number of buffers - 100, time out - 1s
    	//if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_register_read(udev, 0xE, &data);				
   	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("Bulk Transfer: 0x%x\n", data);		// write bulk transfer to screen

	printf("\n\n*****************************************************\n");
	printf("****************** SET UP 1st Ortex AD411 ADC ***********************\n");
	printf("*****************************************************\n");

	N=6;	// Camac slot number 
//	0x5F00 = 1001 1111 0000 0000
//		 B  B BBBB
//		 1  1 1119
//		 6  3 210
//	B16 =1 => Overflow-suppresion
//	B13 =1 => Singles mode
//	B12 =1 => Master Gate ignored
//	B11 =1 => Local Gate ignored
//	B10 =1 => Camac readout enabled
//	B9  =1 => Zero-suppression ? ? ?
	//ret = CAMAC_write(udev, N, 0, 16, 0x5F00, &Q, &X);	// no FERA
	CDATA=0x1401;
	ret = CAMAC_write(udev, N, 0, 16, CDATA, &Q, &X);	// using FERA
	//ret = CAMAC_write(udev, N, 0, 16, 0xD600, &Q, &X);	// 
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_read(udev,  N, 0, 0, &data, &Q, &X);				
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("ADC Control Register: 0x%x\n", data);	// write Control register to screen

//   	ret = CAMAC_write(udev, N, 0, 17, 0xC, &Q, &X);	2mv * val = LLD
//  	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
   	ret = CAMAC_read(udev,  N, 0, 1, &data, &Q, &X);				
  	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
  	data = (data & 0xFF);
   	printf("LLD: 0x%x\n", data);			//write LLD to screen

//  	ret = CAMAC_write(udev, N, 1, 17, 0x0, &Q, &X);	// 8.5V + 0.008V * val = ULD
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
        	ret = CAMAC_read(udev,  N, 1, 1, &data, &Q, &X);				
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
 	data = (data & 0xFF);
  	printf("ULD: 0x%x\n", data);			// write ULD to screen

//  	ret = CAMAC_write(udev, N, 2, 17, 0xFF, &Q, &X);// -40V + 0.312V * val = OFFSET
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
//  	ret = CAMAC_read(udev,  N, 2, 1, &data, &Q, &X);				
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
// 	data = (data & 0xFF);
//  	printf("DC Offset: 0x%x\n", data);		// write DC Offset to screen

// ------------------------------------------------------------------------

	printf("\n\n*****************************************************\n");
	printf("****************** SET UP 2nd Ortex AD411 ADC ***********************\n");
	printf("*****************************************************\n");

	N=2;	// Camec slot number
//	0x5F00 = 1001 1111 0000 0000
//		 B  B BBBB
//		 1  1 1119
//		 6  3 210
//	B16 =1 => Overflow-suppion
//	B13 =1 => Singles mode
//	B12 =1 => Master Gate ignored
//	B11 =1 => Local Gate ignored
//	B10 =1 => Camac readout enabled
//	B9  =1 => Zero-suppression ? ? ?
	CDATA=0x9C02;
	CDATA=0x1402;
	ret = CAMAC_write(udev, N, 0, 16, CDATA, &Q, &X);	// using FERA
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	ret = CAMAC_read(udev,  N, 0, 0, &data, &Q, &X);				
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	printf("ADC Control Register: 0x%x\n", data);	// write Control register to screen

   	ret = CAMAC_read(udev,  N, 0, 1, &data, &Q, &X);				
  	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
  	data = (data & 0xFF);
   	printf("LLD: 0x%x\n", data);			//write LLD to screen

//  	ret = CAMAC_write(udev, N, 1, 17, 0x0, &Q, &X);	// 8.5V + 0.008V * val = ULD
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
        	ret = CAMAC_read(udev,  N, 1, 1, &data, &Q, &X);				
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
 	data = (data & 0xFF);
  	printf("ULD: 0x%x\n", data);			// write ULD to screen

//  	ret = CAMAC_write(udev, N, 2, 17, 0xFF, &Q, &X);// -40V + 0.312V * val = OFFSET
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
//  	ret = CAMAC_read(udev,  N, 2, 1, &data, &Q, &X);				
// 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
// 	data = (data & 0xFF);
//  	printf("DC Offset: 0x%x\n", data);		// write DC Offset to screen

// ------------------------------------------------------------------------
// -------- end of ORTEC AD114 setup(s)
	
// ------------------------------------------------------------------------

	printf("\n\n***********************************************************************\n");
	printf("****************** SET UP the LeCroy 4302 FERA memory *********************\n");
	printf("***************************************************************************\n");

	N=14;	// Camac slot
  	ret = CAMAC_write(udev, N, 1, 17, 0x1, &Q, &X);	// Set 4302 to CAMAC Mode
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
  	ret = CAMAC_write(udev, N, 0, 17, 0x0, &Q, &X);	// Set 4302 to first memory add
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
  	ret = CAMAC_write(udev, N, 1, 17, 0x3, &Q, &X);	// Set 4302 to ECL Mode
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
  	ret = CAMAC_write(udev, N, 1, 26, 0x0, &Q, &X);	// Set 4302 to enable LAM
 	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }

	// clear Inhibit
  	//ret = CAMAC_write(udev, 29, 9, 26, 0x0, &Q, &X);	// Clear CAMAC Inhibit
 	//if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }


	printf("\n\n*****************************************************\n");
	printf("****************** SET UP Lecroy 4300B  ADC ***********************\n");
	printf("*****************************************************\n");

	//ret = CAMAC_write(udev, N, A, N, 0xABCD, &Q, &X);	// proto-skeleton
	N=10; A=0; F=16; CDATA=0x0404;
	ret = CAMAC_write(udev, N, A, F, CDATA, &Q, &X);	
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	//ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
	N=10; A=0; F=0; data=0;
	ret = CAMAC_read(udev, N, A, F, &data, &Q, &X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,data, Q,X,ret); return 1; }
	printf("Read back of 4300b ADC CSR = %X Q= %d X=%d \n", data,Q,X);
	// issue an initial clear
	N=10; A=0; F=9; CDATA=0x0;
	ret = CAMAC_write(udev, N, A, F, CDATA, &Q, &X);	
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }

	
if ( 1==1) {	// this test can illiminate the configuration of the TDC

	printf("\n\n*****************************************************\n");
	printf("****************** SET UP Lecroy 3377 TDC ***********************\n");
	printf("*****************************************************\n");

	int iii=0;
	//ret = CAMAC_write(udev, N, A, F, 0xABCD, &Q, &X);	// proto-skeleton
	//ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
	N=8; A=0; F=9; // clear all data and events
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("%d 1 Using N=%d A=%d F=%d Returns Q=%d X=%d\n",iii, N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	sleep(1);

	A=0;F=24;
	ret = CAMAC_write(udev, N, A, F, 0x0000, &Q, &X);	// disable DAQ mode on TDC
	printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	sleep(1);

// Go thru steps to change mode...
/* 
	N=8; A=0; F=9; // clear all data and events
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("2 Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	sleep(1);
	F=30;
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }

	// do not change from mode=0
	if ( 0==1) { // if true; change to mode 1: Common start, Single word
		printf("Changing to mode 1...\n");
		F=21;
		ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
		printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 		if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	}

	F=20;A=0;
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	F=25;A=0;
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	int Qcounter=0;
	Q=0;
	while ( Q == 0 ) {
		printf("Waiting on Xilinx programming to complete...\n");
		sleep(1);
		F=13;
		ret = CAMAC_read(udev, N, A, F, &data, &Q, &X);	// proto-skeleton
		Qcounter++;
		printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 		if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
		printf(" Q=%d X=%d\n", Q,X);
		if ( Qcounter >= 0 ) break;
	}
 */
/*
	N=8; A=0; F=9; // clear all data and events
	ret = CAMAC_write(udev, N, A, F, 0x0, &Q, &X);	// proto-skeleton
	printf("3 Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
 	if(ret<0) { printf("Error on NAF=%d %d %d Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	sleep(1);
 */

// Done with steps


	CDATA0 = 0x0803;	// Ramberg recomendations
	CDATA1 = 0x02FF;	// Ramberg recomendations
	CDATA2 = 0x03D1;	// Ramberg recomendations
	CDATA3 = 0x000F;	// Ramberg recomendations
	// begin setting Control Registers 0,1,2,3
	N=8; A=0; F=17; 
	ret = CAMAC_write(udev, N, A, F, CDATA0, &Q, &X);	// proto-skeleton
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,CDATA0,Q,X,ret); return 1; }
	N=8; A=0; F=1;
	ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,data,Q,X,ret); return 1; }
	printf("Read back of 3377 TDC Control Reg 0 = %X Q=%d X=%d\n",data, Q, X);
	// -----------
	N=8; A=1; F=17; 
	ret = CAMAC_write(udev, N, A, F, CDATA1, &Q, &X);	// proto-skeleton
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,CDATA1,Q,X,ret); return 1; }
	N=8; A=1; F=1;
	ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,data,Q,X,ret); return 1; }
	printf("Read back of 3377 TDC Control Reg 1 = %X Q=%d X=%d\n",data, Q, X);
	// ----------
	N=8; A=2; F=17; 
	ret = CAMAC_write(udev, N, A, F, CDATA2, &Q, &X);	// proto-skeleton
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,CDATA2,Q,X,ret); return 1; }
	N=8; A=2; F=1;
	ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,data,Q,X,ret); return 1; }
	printf("Read back of 3377 TDC Control Reg 2 = %X Q=%d X=%d\n",data, Q, X);
	// ----------
	N=8; A=3; F=17; 
	ret = CAMAC_write(udev, N, A, F, CDATA3, &Q, &X);	// proto-skeleton
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,CDATA3,Q,X,ret); return 1; }
	N=8; A=3; F=1;
	ret = CAMAC_read(udev,  N, A, F, &data, &Q, &X);	// proto-skeleton		
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,data,Q,X,ret); return 1; }
	printf("Read back of 3377 TDC Control Reg 3 = %X Q=%d X=%d\n",data, Q, X);
	// ----------
	//may not need or may need to delay the next operation
/* */
	N=8; A=1; F=26; // enable Data Acquisition Mode
	ret = CAMAC_write(udev, N, A, F, 0x0000, &Q, &X);	// proto-skeleton
 	if(ret<0) { printf("Error on NAF=%d %d %d Data=%X Q=%d X=%d return value= %i\n", 
			N,A,F,Q,X,ret); return 1; }
	printf("Using N=%d A=%d F=%d Returns Q=%d X=%d\n", N, A, F, Q, X);
/* */

} // end of if ( 0==1) test....

/* 	// for abnormal exit....  only used for debugging 
	printf("------------------ Exit early-------------------\n");
	CAMAC_I(udev, 0x1);
	ret = xxusb_device_close(udev);
        if(ret<0) { printf("\n\nError CC-USB did not close properly, return value= %i\n", ret);
				 return 1; }
	return 0;

  */

	printf("\n\n*****************************************************\n");
	printf("************** CREATE CC-USB STACK ******************\n");
	printf("*****************************************************\n");

	long writestack[100];
	long readstack[100];
	for ( i=0; i<100; i++ ) { writestack[i]=readstack[i]=0;}
	// stack as used by Camden in laser lab
	writestack[0] = 0x4;			// number of lines in stack
	//writestack[1] = 0x0802;		// read ADC N(4), A(0), F(2)
	writestack[1] = 0x1402;		// read ADC N(10), A(0), F(2)
	//writestack[2] = 0x1402;		// read ADC N(10), A(0), F(2)
	//writestack[1] = 0x0A02;		// read ADC N(5), A(0), F(2)
	writestack[2] = 0x393D;		// CAMAC_C command
	writestack[3] = 0x0010;		// write end number N(0), A(0), F(16)
	writestack[4] = 0xFFFF;		// end number 0xFFFF

	//To calculate the stack pattern for NAF and longmode on/off
	//command = F + 32*A + 512*N + 16384*LongNodeOn

        // stack for FERA readout	//  interpretation
        writestack[0] = 0x000d;		//  number of commands in the stack
        writestack[1] = 0x3B38;         //  N A F = 29 9 24     Set CAMAC Inhibit I
        writestack[2] = 0x1C31;         //  N A F = 14 1 17     Set 4302 to CAMAC mode
        writestack[3] = 0x0001;         //  data for above
        writestack[4] = 0x1C11;         //  N A F = 14 0 17     Set 1st Memory Address in 4302
        writestack[5] = 0x0000;         //  data for above
        writestack[6] = 0x9c00;         //  N A F = 14 0 0      Read Data from 4302 & incr addres
        writestack[7] = 0x8010;         //  continue was set above, ask for Q scan
        writestack[8] = 0x1fa0;         //  with number of repeats 8096 (dec)
        writestack[9] = 0x1C11;         //  N A F = 14 0 17     Set 4302 memory addres to
        writestack[10] = 0x0000;        //  data for above
        writestack[11] = 0x1C31;        //  N A F = 14 1 17     Set 4302 mode to
        writestack[12] = 0x0003;        //  data for above      ECL mode
        writestack[13] = 0x3B3A;        //  N A F = 29 9 26     Clear CAMAC Inhibit I


	printf("***** WRITTING STACK TO CC-USB *****\n");
	ret = xxusb_stack_write(udev, 2, writestack);		// write to cc-usb stack
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }

	printf("***** READING STACK FROM CC-USB *****\n");
	ret = xxusb_stack_read(udev, 2, readstack);		// read from cc-usb stack
	if(ret<0) { printf("Error, return value= %i\n", ret); return 1; }
	i = 0;
	do
	{	
		printf("readstack[%d]: 0x%x\n", i, readstack[i]);
		i++;
	}
	while ( readstack[i] != 0 );

	if ( ret != 2*(writestack[0]+1) ) { 
		printf("Bad stack length readback: ret=%d, writestack[0]=%d readstack[0]=%d\n",
			ret,writestack[0], readstack[0] );
		for (i=0; i<ret/2; i++) printf("readstack[%d] = %x\n",i,readstack[i]);
		printf("Exit early with 'return 1'\n");
	} else {
		for (i=0; i<ret/2; i++) printf("readstack[%d] = %x\n",i,readstack[i]);
	}

	// *****************************************************
	// ******************* TAKE DATA ***********************
	// *****************************************************
	
	long data_lines;
	int loops = 100;	// read just one time
	int event_size = 0, events = 0;
	int j, k;

	printf("\n***** START TAKING DATA *****\n");
	CAMAC_I(udev, 0x0);
	ret = xxusb_register_write( udev, 0x1, 0x1);// start cc-usb data acquisition in list mode
	i=0;
	int error_count=0, loopcounter=0;
	while ( i < loops)
	{
		loopcounter++;
		for (j=0; j<10000; j++) IntArray[j]=0;		// clear data array
		gettimeofday(&tpstart, NULL);
		ret = xxusb_bulk_read(udev, IntArray, 8192, 500);// read the usb fifo
		gettimeofday(&tpend,NULL);
		timedif= MILLION*(tpend.tv_sec -tpstart.tv_sec) + tpend.tv_usec-tpstart.tv_usec;
		printf("In loop: time to run xxusb_bulk_read is %d usec\n", timedif);

	
		printf("In loop IntArray[0..11]:" );
		for ( j=0; j<12; j++) printf( " %x", IntArray[j]);
		printf("\n");
/*
		printf("In loop IntArray[0..11] by 16bit words.\n" );
		for ( j=0; j<12; j++) {
				printf(" j=%d IntArray[%d]=%4x ", j, j, (short) IntArray[j]);
				printf(" %4x ", getbits(IntArray[j],15,16) );
				printf(" %4x ", getbits(IntArray[j],31,16) );
				printf(" sizeof(IntArray[%d])=%d \n", j,sizeof(IntArray[j]) );
		}
		printf("\n");
 */

		data_lines = ret / 2;
		printf("at loopcounter=%d i=%d after xxusb_bulk_read() ret=%d data_lines=%d\n"
			,loopcounter,i,ret,data_lines);
		if (event_size > 0x100) event_size = 0x100;
		if (data_file !=NULL)
		{
			if(ret>0)
			{
				events = (IntArray[0]& 0xffff);
				printf("READ Events in loop %i: %i(dec) %X(hex)\n",
						i,events,events);
			        fprintf(data_file,"%d\t%d\t%d\n", -1, tpstart.tv_sec, 
								tpstart.tv_usec);
			        fprintf(data_file,"%d\t%d\t%d\n", -2, tpend.tv_sec, 
								tpend.tv_usec);
				for (j=0; j<data_lines; j++) 
				  {
				    DATA = (IntArray[j] &0xffff);
				    RAW  = IntArray[j];
				    //fprintf(data_file,"%4d FIL=%X\tRAW=%X\n",j,DATA,RAW);
				    DATA = (short) getbits(IntArray[j],15,16);
				    //fprintf(data_file,"%d\t%X\t%d\n", j, DATA,DATA);
				    fprintf(data_file,"%d\t%X\t%d\n",j,IntArray[j],IntArray[j]);
				  }
				i++;
			}
			else
			{
				error_count++;
				printf("NO READ at error_count=%d, loopcounter=%d, i=%d \n",
					error_count, loopcounter, i);
				if ( error_count > numNoReads ) {
					printf("%d is too many 'no read' errors, break...\n",
					numNoReads);
					break;
				}
			}
		}
	}
	
	ret = xxusb_register_write( udev, 0x1, 0x0);	// stop cc-usb data acquisition 
	if(ret<0) { printf("\n\nError, return value= %i\n", ret); return 1; }

	// drain all data from fifo
	ret=1;
	k=0;
	while(ret>0)
	{
		for (j=0; j<10000; j++) IntArray[j]=0;		// clear data array
		gettimeofday(&tpstart, NULL);
		ret = xxusb_bulk_read(udev, IntArray, 8192, 100);
		gettimeofday(&tpend, NULL);
		if(ret>0)
		{
			printf("drain loops: %i (result %i bytes)\n ",k,ret);
			//printf("In drain: IntArray[0:3]: %x %x %x %x\n", 
			//	IntArray[0], IntArray[1], IntArray[2],IntArray[3]);
			printf("In drain IntArray[0..11]:\n" );
		        fprintf(data_file,"%d\t%d\t%d\n", -1, tpstart.tv_sec, 
								tpstart.tv_usec);
			fprintf(data_file,"%d\t%d\t%d\n", -2, tpend.tv_sec, 
								tpend.tv_usec);
			for ( j=0; j<ret/2; j++){
				//printf( "%d %x %d\n", j,IntArray[j],IntArray[j]);
				fprintf(data_file,"%d\t%X\t%d\n", j, IntArray[j],IntArray[j]);
			}
			k++;
			if (k>100){printf("Reached 100 limit\n"); ret=0;}
		}
	}
	printf("Did k=%d itterations of drain at end.\n",k);

	printf("/nTurn on Camac I inhibit at end.\n");
	CAMAC_I(udev, 0x1);


	ret = xxusb_device_close(udev);
        if(ret<0) { printf("\n\nError CC-USB did not close properly, return value= %i\n", ret);
				 return 1; }

	printf("\n\n***** Normal END *****\n\n");

	return 0;
}
/*	for abnormal exit....
	CAMAC_I(udev, 0x1);
	ret = xxusb_device_close(udev);
        if(ret<0) { printf("\n\nError CC-USB did not close properly, return value= %i\n", ret);
				 return 1; }
	return 0;
 */
